PROGRAM Shuffle (infile, outfile);
   (* version 2.6 *)

CONST maxsp = 40;  (* maximum number of species *)
   namesize = 10;  (* length of species name *)

VAR temp           : ARRAY[1..maxsp] OF REAL;
   dist            : ARRAY[1..maxsp] OF ARRAY[1..maxsp] OF REAL;
   names           : ARRAY[1..maxsp] OF ARRAY[1..namesize] OF CHAR;
   tempnames       : ARRAY[1..maxsp] OF CHAR;
   numsp           : INTEGER;
   order           : ARRAY[1..maxsp] OF INTEGER;
   infile, outfile : TEXT;

PROCEDURE getdata;
   VAR i, j : INTEGER;
BEGIN (* getdata *)
   READLN(infile, numsp);
   FOR i := 1 TO numsp DO BEGIN
      FOR j := 1 TO namesize DO READ(infile, names[i][j]);
      FOR j := 1 TO numsp DO BEGIN
         IF EOLN(infile) THEN READLN(infile);
         READ(infile, dist[i][j]);
         END;
      READLN(infile);
      END;
END; (* getdata *)

PROCEDURE mix;
   VAR i, j : INTEGER;
BEGIN (* mix *)
   FOR i := 1 TO numsp DO BEGIN
      FOR j :=1 TO numsp DO temp[j] := dist[i][order[j]];
      FOR j :=1 TO numsp DO dist[i][j] := temp[j];
      END;
   FOR i := 1 TO numsp DO BEGIN
      FOR j := 1 TO numsp DO temp[j] := dist[order[j]][i];
      FOR j := 1 TO numsp DO dist[j][i] := temp[j];
      END;
END; (* mix *)

PROCEDURE getorder;
   VAR i : INTEGER;
BEGIN (* getorder *)
   FOR i := 1 TO numsp DO BEGIN
      IF EOLN(infile) THEN READLN(infile);
      READ(infile, order[i]);
      END;
END; (* getorder *)

PROCEDURE mixnames;
   VAR i, j : INTEGER;
BEGIN (* mixnames *)
   FOR i := 1 TO namesize DO BEGIN
      FOR j := 1 TO numsp DO tempnames[j] := names[order[j]][i];
      FOR j := 1 TO numsp DO names[j][i] := tempnames[j];
      END;
END; (* mixnames *)

PROCEDURE store;
   VAR i, j : INTEGER;
BEGIN (* store *)
   WRITELN(outfile, numsp);
   FOR i := 1 TO numsp DO BEGIN
      FOR j := 1 TO namesize DO WRITE(outfile, names[i][j]);
      FOR j := 1 TO numsp DO WRITE(outfile, dist[i][j]:10:5);
      WRITELN(outfile);
      END;
END; (* store *)

BEGIN (* shuffle *)
   RESET (infile);
   REWRITE (outfile);
   getdata;
   getorder;
   mixnames;
   mix;
   store;
   (*   CLOSE(outfile);   -- may need this here *)
END. (* shuffle *)
